/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cd.hologram.erecettesvg.sql;

/**
 *
 * @author moussa.toure
 */
public class SQLQueryNotePerception {

    public static String SELECT_NOTE_PERCEPTION_BY_CODE = "SELECT * FROM T_NOTE_PERCEPTION WITH (READPAST) WHERE ETAT > 0 AND NUMERO = ?1";

    public static String SELECT_AMR_BY_CODE = "SELECT * FROM T_AMR WITH (READPAST) WHERE NUMERO = ?1";

    public static String SELECT_RETRAIT_DECLARATION_BY_DECLARATION = "SELECT * FROM T_RETRAIT_DECLARATION WITH (READPAST) WHERE CODE_DECLARATION = ?1";
    
    public static String SELECT_RETRAIT_DECLARATION_BY_DECLARATION_V2 = "SELECT * FROM T_RETRAIT_DECLARATION WITH (READPAST) WHERE (ID = %s OR CODE_DECLARATION = ?1)";

    public static String GET_ASSUJETTI_BY_CODE = "SELECT * FROM T_PERSONNE "
            + " WIDTH(READPAST) WHERE CODE = ?1 AND ETAT = 1";

    public static String SELECT_NOTE_PERCEPTION = "SELECT NC.EXERCICE, NC.SERVICE, DBO.FDATE(NP.DATE_CREAT) DATE, NP.NUMERO, NC.NUMERO,"
            + " NP.RECEPTIONNISTE, NP_MERE, NET_A_PAYER, PAYER, SOLDE, NP.NBR_IMPRESSION,NP.DEVISE,"
            + " NC.PERSONNE FROM T_NOTE_PERCEPTION NP WITH (READPAST) "
            + "INNER JOIN T_NOTE_CALCUL NC WITH (READPAST) ON NP.NOTE_CALCUL = NC.NUMERO "
            + "INNER JOIN T_ADRESSE_PERSONNE AP  WITH  (readpast)  ON NC.FK_ADRESSE_PERSONNE = AP.CODE "
            + "INNER JOIN T_PERSONNE P  WITH (READPAST) ON P.CODE = NC.PERSONNE "
            + "WHERE NC.AGENT_CLOTURE IS NOT NULL AND NC.AGENT_VALIDATION IS NOT NULL AND NP.ETAT>0 "
            + "AND (P.NOM LIKE ?1 OR P.POSTNOM LIKE ?1 OR P.PRENOMS LIKE ?1) "
            + "AND (FRACTIONNEE=0 OR FRACTIONNEE IS NULL) AND  (TAXATION_OFFICE= 0 OR TAXATION_OFFICE IS NULL)";

    public static String UPDATE_NOTE_PERCEPTION_PRINT_CASE_1 = "UPDATE T_NOTE_PERCEPTION SET COMPTE_BANCAIRE = ?1 WHERE NUMER0 = ?2 ";

    public static String UPDATE_NOTE_PERCEPTION_PRINT_CASE_2 = ":UPDATE T_NOTE_PERCEPTION SET COMPTE_BANCAIRE = ?1, "
            + "DATE_RECEPTION = CONVERT(DATE,?2,103), "
            + "RECEPTIONNISTE = ?3, "
            + "TIMBRE = ?4, "
            + "PAPIER_SECURISE= ?5, "
            + "SOLDE = ?6, "
            + "DEVISE = ?7, "
            + "TAUX_APPLIQUE = ?8,"
            + "MONTANT_INITIAL = ?9,"
            + "NET_A_PAYER = ?10, DATE_ECHEANCE_PAIEMENT = CONVERT(DATE,?11,103), NBR_IMPRESSION = 1 WHERE NUMERO = ?12";

    public static String UPDATE_SUIVI_COMPTABLE_PRINT = ":UPDATE T_SUIVI_COMPTABLE_DECLARATION  SET DEBIT = ?1, "
            + "SOLDE = ?2, "
            + "DEVISE = ?3 WHERE NC = ?4 AND DEBIT > 0";

    public static String UPDATE_JDOSSIER_PRINT = ":UPDATE T_JDOSSIER SET DEBIT = ?1, "
            + "SOLDE = ?2, "
            + "DEVISE = ?3 WHERE REFERENCE = ?4";

    public static String UPDATE_NBRE_IMPRESSION = ":UPDATE T_NOTE_PERCEPTION SET NBR_IMPRESSION=NBR_IMPRESSION+1 WHERE NUMERO = ?1";

    public static String SELECT_ACCOUNT_BANK_BY_CODE = "SELECT C.* FROM T_COMPTE_BANCAIRE C WITH(READPAST) WHERE C.CODE = ?1";

    public static String SELECT_LIST_BUDGET_ARTICLES_BY_NC = "SELECT TOP 1 AB.* FROM T_ARTICLE_BUDGETAIRE AB WITH(READPAST) WHERE AB.CODE IN (SELECT "
            + " DISTINCT ARTICLE_BUDGETAIRE FROM T_DETAILS_NC WITH(READPAST) WHERE NOTE_CALCUL = ?1 AND ETAT = 1) "
            + " AND AB.ETAT = 1";

    public static String SELECT_TARIF_BY_CODE = "SELECT * FROM T_TARIF WITH(READPAST) WHERE CODE = ?1 AND ETAT = 1";

    public static String SELECT_ARCHIVE_BY_REF_DOCUMENT = "SELECT * FROM T_ARCHIVE WITH(READPAST) WHERE REF_DOCUMENT = ?1 AND DOCUMENT_STRING IS NOT NULL";

    public static String SELECT_DETAILS_NC_BY_NC = "SELECT * FROM T_DETAILS_NC WITH(READPAST) WHERE NOTE_CALCUL = ?1 AND ETAT = 1";

    public static String SELECT_DOCUMENT_OFFICIEL_BY_CODE = "SELECT * FROM T_DOCUMENT_OFFICIEL WITH(READPAST) WHERE CODE = ?1 AND ETAT = 1";

    public static String SELECT_LAST_SERIE_BY_SITE = "SELECT TOP 1 ANNEE, PREFIX, SITE, DEBUT, FIN, DERNIER_NUMERO_IMPRIME, NOMBRE_NOTE_IMPRIMEE, ID,"
            + " SERIE_FINIE FROM T_SERIE WHERE SITE= ?1 AND ETAT=1 AND SERIE_FINIE=0 ORDER BY ID";

    public static String ARCHIVE_ACCUSER_RECEPTION = ":EXEC F_NEW_ARCHIVE_ACCUSE_RECEPTION '%s',?1,?2,?3,?4";
    public static String ARCHIVE_ACCUSER_RECEPTION_V2 = ":EXEC F_NEW_ARCHIVE_ACCUSE_RECEPTION ?1,?2,?3,?4,?5";

    public static String UPDATE_BP_PRINT = ":UPDATE T_BON_A_PAYER SET ETAT_IMPRESSION = 1 "
            + " WHERE CODE = ?1  ";

    public static String SELECT_NOTE_PERCEPTION_FOR_FRACTION = "SELECT  NP.* FROM T_NOTE_PERCEPTION NP WITH (READPAST) "
            + " WHERE NP.ETAT IN(1,2) AND NP.NUMERO = ?1 AND NP.NOTE_CALCUL IN (SELECT NC.NUMERO FROM T_NOTE_CALCUL NC WITH (READPAST) WHERE NC.PERSONNE = ?2)";

    public static String SELECT_NOTE_PERCEPTION_BY_ASSUJETTI_V2 = "SELECT  NP.* FROM T_NOTE_PERCEPTION NP WITH (READPAST) "
            + " WHERE NP.ETAT IN (1,2) AND NP.NP_MANUEL = ?1 "
            + " AND NP.NOTE_CALCUL IN (SELECT NC.NUMERO FROM T_NOTE_CALCUL NC WITH (READPAST) WHERE NC.PERSONNE = ?2) %s";

    public static String ARCHIVE_ACCUSER_RECEPTION_v2 = ":EXEC F_NEW_ARCHIVE_ACCUSE_RECEPTION '%s',?1,?2,?3,?4";

    //public static String SELECT_BP_INTERET_BY_NP = "SELECT * FROM T_BON_A_PAYER WHERE NP_MERE = ?1 AND TYPE_BP = 3";
    public static String SELECT_BP_INTERET_BY_NP = "SELECT * FROM T_BON_A_PAYER WHERE CODE = ?1";

    public static String SELECT_BP_INTERET_BY_BP = "SELECT * FROM T_NOTE_PERCEPTION WHERE BP_MERE = ?1 AND FK_TYPE_TITRE_PERCEPTION = 11";

    public static String F_NEW_NOTE_PERCEPTION_PENALITEV2 = ":EXEC F_NEW_NOTE_PERCEPTION_PENALITEV2 ?1,?2,?3,?4,?5,?6,?7,?8,?9,?10,?11,?12,?13,?14,?15,?16,?17";

    public static String SELECT_NOTE_PERCEPTION_FRACTIONNE = "SELECT * FROM T_NOTE_PERCEPTION WITH (READPAST) WHERE  NUMERO = ?1 AND FRACTIONNEE = 1";

    public static String SELECT_LIST_NP_FILLE_BY_Mere = "SELECT NP.* FROM T_NOTE_PERCEPTION NP WITH (READPAST) "
            + " WHERE NP.NP_MERE = ?1 AND NP.ETAT > 0";

    public static String F_CLOSE_NP_FRACTIONNE = ":UPDATE T_NOTE_PERCEPTION SET ETAT = 0 WHERE NUMERO = ?1 ";

    public static String F_ANNULE_FRACTIONNEMENT_NP_MERE = ":UPDATE T_NOTE_PERCEPTION SET FRACTIONNEE = 0 WHERE NUMERO = ?1 ";

    public static String F_ANNULATION_DETAILS_FRACTIONNEMENT_AFTER_REVOCATION = ":UPDATE T_DETAIL_ECHELONNEMENT "
            + " SET ETAT = 3 WHERE FK_DEMANDE_ECHELONNEMENT = ?1";

    public static String F_ANNULATION_DEMANDE_FRACTIONNEMENT_AFTER_REVOCATION = ":UPDATE T_DEMANDE_ECHELONNEMENT "
            + " SET ETAT = 0 WHERE CODE = ?1";

    public static String UPDATE_RETRAIT_DECLARATION = "UPDATE T_RETRAIT_DECLARATION SET AVIS = ?1, OBSERVATION_CONTROLE = ?2 WHERE ID = ?3";

    public static String SELECT_LIST_NOTE_PERCEPTION_BY_EXTRAIT_ROLE = "SELECT NP.* FROM T_NOTE_PERCEPTION NP "
            + " WITH (READPAST) WHERE NP.NUMERO IN (SELECT DISTINCT DR.DOCUMENT_REF FROM T_DETAILS_ROLE DR "
            + " WITH (READPAST) WHERE DR.FK_EXTRAIT_ROLE = ?1) AND NP.NUMERO NOT IN (SELECT DISTINCT J.DOCUMENT_APURE "
            + " FROM T_JOURNAL J WITH (READPAST))";

    public static String F_UPDATE_EXTRAIT_ROLE = ":UPDATE T_EXTRAIT_DE_ROLE SET ORDONNANCE = 1, ETAT = 1 WHERE ID = ?1";

    public static String F_UPDATE_DETAIL_ROLE = ":UPDATE T_DETAILS_ROLE SET ORDONNANCE = 1 WHERE FK_EXTRAIT_ROLE = ?1";

    public static String F_UPDATE_ECHEANCE_NP = ":UPDATE T_NOTE_PERCEPTION SET DATE_ECHEANCE_PAIEMENT = ?1 "
            + " WHERE NOTE_CALCUL = ?2 AND FK_TYPE_TITRE_PERCEPTION = 3";
    
    public static String F_NEW_NOTE_PERCEPTION_PENALITEV3 = ":EXEC F_NEW_NOTE_PERCEPTION_PENALITEV3 ?1,?2,?3,?4,?5,?6,?7,?8,?9,?10,?11,?12,?13,?14,?15,?16,?17,?18";
    public static String F_NEW_NOTE_PERCEPTION_PENALITE = ":EXEC F_NEW_NOTE_PERCEPTION_PENALITE ?1,?2,?3,?4,?5,?6,?7,?8,?9,?10,?11,?12,?13,?14,?15,?16,?17";
    
    public static String F_NEW_BON_A_PAYER_PENALITE = ":EXEC F_NEW_BON_A_PAYER_PENALITE ?1,?2,?3,?4,?5,?6,?7,?8,?9";
    public static String F_NEW_BON_A_PAYER_PENALITEV3 = ":EXEC F_NEW_BON_A_PAYER_PENALITEV3 ?1,?2,?3,?4,?5,?6,?7,?8,?9,?10";
    public static String F_NEW_BON_A_PAYER_PENALITEV2 = ":EXEC F_NEW_BON_A_PAYER_PENALITEV2 ?1,?2,?3,?4,?5,?6,?7,?8,?9,?10";
}
